import { Component } from "react";
import { View, Image, Text, ScrollView } from "@tarojs/components";
import { AtTabs, AtActivityIndicator } from "taro-ui";
import "./index.less";
import Taro from "@tarojs/taro";
export default class Index extends Component {
  state = {
    current: 0,
    page: 1, //页数
    loading: false, //加载状态
    totalPages: 1, // 添加总页数
    isNoMore: false, // 是否没有更多
    productList: [], //商品列表
    tags: [
      { title: "全部" },
      { title: "限时秒杀" },
      { title: "限时秒杀" },
      { title: "限时秒杀" },
      { title: "限时秒杀" },
      { title: "限时秒杀" },
      { title: "限时秒杀" },
    ],
    productList: [
      {
        id: 1,
        name: "新款时尚连衣裙2024春新款时尚连衣裙2024春新款时尚连衣裙2024春",
        price: "29.00",
        commission: "29.9",
        image: "https://yushi.tos-cn-beijing.volces.com/products/product1.png",
      },
      {
        id: 2,
        name: "轻奢真皮小方包",
        price: "458.00",
        commission: "45.8",
        image: "https://yushi.tos-cn-beijing.volces.com/products/product2.png",
      },
      {
        id: 3,
        name: "高端蚕丝围巾披肩",
        price: "199.00",
        commission: "19.9",
        image: "https://yushi.tos-cn-beijing.volces.com/products/product3.png",
      },
      {
        id: 4,
        name: "925纯银项链女",
        price: "328.00",
        commission: "32.8",
        image: "https://yushi.tos-cn-beijing.volces.com/products/product4.png",
      },
      {
        id: 5,
        name: "小众设计感衬衫",
        price: "268.00",
        commission: "26.8",
        image: "https://yushi.tos-cn-beijing.volces.com/products/product5.png",
      },
    ],
  };
  componentDidMount() {}
  // 获取商品列表
  getBrowseShopProductList = async (isRefresh = false) => {
    const { page } = this.state;
    this.setState({ loading: true });

    const res = await getBrowseShopProductList({
      tag_name: this.state.tabList[this.state.current].title,
      page,
      page_size: 10,
    });

    this.setState((prevState) => ({
      productList: isRefresh
        ? res.goods_list
        : [...prevState.productList, ...res.goods_list],
      totalPages: res.total_pages,
      loading: false,
    }));
  };
  // 返回
  handleBack = () => {
    Taro.navigateBack();
  };
  // 切换tab
  tabClick = (index) => {
    this.setState({
      current: index,
      // page: 1,
      // productList: [],
      // isNoMore: false,
      // isLoading: false,
    });
    // this.getBrowseShopProductList(true);
  };
  // 滚动到底部
  handleScrollToLower = () => {
    console.log("滚动到底部");
    return;
    const { page, totalPages, loading } = this.state;
    if (page < totalPages && !loading) {
      this.setState(
        (prevState) => ({ page: prevState.page + 1 }),
        () => this.getBrowseShopProductList()
      );
    }
  };
  render() {
    return (
      <View className="index">
        {/* 返回按钮 */}
        <Image
          onClick={this.handleBack}
          style={{ top: Taro.navigationBarHeight + "px" }}
          className="top-back"
          src="https://yushi.tos-cn-beijing.volces.com/activity/back.png"
          mode="widthFix"
        />
        {/* 顶部图片包裹盒子 */}
        <View className="top-img-wrap">
          <Image
            className="top-img"
            src="https://yushi.tos-cn-beijing.volces.com/activity/topImg.png"
            mode="widthFix"
          />
          <Image
            className="top-title-img"
            src="https://yushi.tos-cn-beijing.volces.com/activity/titleImgOne.png"
            mode="widthFix"
          />
        </View>
        {/* 专场 */}
        <View className="activity-wrap">
          <View className="topBox">
            <View className="item">
              <View className="item-title">下午茶专场</View>
              <Image
                className="item-img"
                src="https://yushi.tos-cn-beijing.volces.com/activity/topOne.png"
                mode="widthFix"
              />
              <View className="item-text">点击进入</View>
            </View>
            <View className="item">
              <View className="item-title">餐饮美食专场</View>
              <Image
                className="item-img"
                src="https://yushi.tos-cn-beijing.volces.com/activity/topTwo.png"
                mode="widthFix"
              />
              <View className="item-text">点击进入</View>
            </View>
          </View>
          <View className="centerBox">
            <View className="item">
              <View className="item-title">酒店出行专场</View>
              <Image
                className="item-img"
                src="https://yushi.tos-cn-beijing.volces.com/activity/centerOne.png"
                mode="widthFix"
              />
              <View className="item-text">点击进入</View>
            </View>
            <View className="item">
              <View className="item-title">清洗服务专场</View>
              <Image
                className="item-img"
                src="https://yushi.tos-cn-beijing.volces.com/activity/centerTwo.png"
                mode="widthFix"
              />
              <View className="item-text">点击进入</View>
            </View>
            <View className="item">
              <View className="item-title">游玩娱乐专场</View>
              <Image
                className="item-img"
                src="https://yushi.tos-cn-beijing.volces.com/activity/centerThree.png"
                mode="widthFix"
              />
              <View className="item-text">点击进入</View>
            </View>
          </View>
          <View className="bottomBox">
            <View className="item">
              <View className="item-title">咖啡专场</View>
              <Image
                className="item-img"
                src="https://yushi.tos-cn-beijing.volces.com/activity/bottom.png"
                mode="widthFix"
              />
              <View className="item-text">点击进入</View>
            </View>
          </View>
        </View>
        <Image
          className="bottom-title-img"
          src="https://yushi.tos-cn-beijing.volces.com/activity/titleImgOne.png"
          mode="widthFix"
        />
        {/* 商品列表盒子 */}
        <View className="product-list-wrap">
          {/* tab分类 */}
          <View className="tabs-list">
            <AtTabs
              current={this.state.current}
              scroll
              tabList={this.state.tags}
              onClick={this.tabClick}
            />
          </View>
          <ScrollView
            onScrollToLower={this.handleScrollToLower}
            className="product-list"
            scrollY
          >
            <View className="product-list-container">
              {this.state.productList.map((product) => (
                <View key={product.id} className="product-list-item">
                  <Image
                    className="product-img"
                    src={product.image}
                    mode="aspectFill"
                  />
                  <View className="product-content">
                    <Text className="product-title">{product.name}</Text>
                    <View className="product-price">
                      <View className="product-price-left">
                        <Text className="product-price-text">到手价</Text>
                        <Text className="product-price-text-price">
                          ¥{product.price}
                        </Text>
                      </View>
                      <View className="product-commission">
                        <Text className="product-commission-text">
                          赚¥{product.commission}
                        </Text>
                      </View>
                    </View>
                  </View>
                </View>
              ))}
              {this.state.loading && (
                <View className="loading">
                  <AtActivityIndicator
                    content="加载中..."
                    isOpened={this.state.loading}
                    mode="center"
                    color="#fff"
                  />
                </View>
              )}
            </View>
          </ScrollView>
        </View>
      </View>
    );
  }
}
